Bug 508525 - Review Request: gjs - Javascript Bindings for GNOME
Review Request: gjs - Javascript Bindings for GNOME
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Owen Taylor
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-06-28 07:17 EDT by Peter Robinson
Modified: 2009-08-11 09:36 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-08-11 09:36:10 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
otaylor: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Peter Robinson 2009-06-28 07:17:47 EDT
SPEC: 
SRPM: 

Gjs is a Javascript binding for GNOME. It's mainly based on Spidermonkey 
javascript engine and the GObject introspection framework.
Comment 1 Yanko Kaneti 2009-06-28 09:03:51 EDT
Let me fix that for you ;)

SPEC: http://pbrobinson.fedorapeople.org/gjs.spec
SRPM: http://pbrobinson.fedorapeople.org/gjs-0.2-1.fc11.src.rpm
Comment 2 Alexander Boström 2009-07-07 17:37:01 EDT
The License field needs to conform to the boolean format as described at https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#Combined_Dual_and_Multiple_Licensing_Scenario and a clarifying comment should be added above it.
Comment 3 Alexander Boström 2009-07-07 17:52:19 EDT
rpmlint warns about missing documentation in -devel. I can't find anything in the guidelines about that, but in any case, there is now an 0.3 release which does contain three files doc/*.txt which seems suitable for %doc in -devel.
Comment 4 Alexander Boström 2009-07-07 17:54:06 EDT
(In reply to comment #3)
> I can't find anything in the guidelines about that

...being a fatal problem, especially for a subpackage, was what I meant to write.
Comment 5 Peter Robinson 2009-07-08 02:41:44 EDT
I'll update the package today. I don't believe no docs is a blocker, given that in a lot of cases now the devel docs are split into a -docs package to allow it to be noarch.
Comment 6 Peter Robinson 2009-07-08 05:37:01 EDT
SPEC: As above
SRPM: http://pbrobinson.fedorapeople.org/gjs-0.3-1.fc11.src.rpm

I've updated the license and added an explanation. The docs are in git but are't part of the release tarball as yet.
Comment 7 Alexander Boström 2009-07-08 17:39:47 EDT
Grmbl. You're right, but the doc/*.txt thing still smells of "someone forgot to put them in EXTRA_DIST in Makefile.am", i.e. a bug for upstream.

Source0 is wrong, replace 0.2 with %{version}.

It looks like 0.3 gained this:
gjs.i586: W: shared-lib-calls-exit /usr/lib/libgjs-dbus.so.0.0.0 exit@GLIBC_2.0

gjs-dbus is new in 0.3. I'll try to understand if this is the normal way to use DBus.

I haven't done an informal but full review yet. I'll get to it...
Comment 8 Alexander Boström 2009-07-09 08:11:19 EDT
(In reply to comment #7)
> Grmbl. You're right, but the doc/*.txt thing still smells of "someone forgot to
> put them in EXTRA_DIST in Makefile.am", i.e. a bug for upstream.

I asked on IRC, they said it probably was so. Please file an upstream bug and make sure the files gets included in -devel unless they change their minds about it.
Comment 9 Peter Robinson 2009-07-10 04:07:54 EDT
> I asked on IRC, they said it probably was so. Please file an upstream bug and
> make sure the files gets included in -devel unless they change their minds
> about it.  

I'll do that over the weekend, I don't see that as a showstopper for a review.
Comment 10 Peter Robinson 2009-07-18 09:11:17 EDT
Colin has said he'll review this one so assigning it to him :)
Comment 11 Owen Taylor 2009-08-06 19:08:04 EDT
Taking the review
Comment 12 Owen Taylor 2009-08-07 11:36:18 EDT
xulrunner-devel-unstable dependency isn't needed - at least on F11, jsapi.h and mozilla-js.pc are part of the main xulrunner-devel.

-devel subpackage requirement on gtk-doc doesn't seem needed. (gtk-doc is a tool for generating documentation from sources.)

Suggest adding a '%check' section with 'make check'

%description
Gjs is a Javascript binding for GNOME. It's mainly based on Spidermonkey 
javascript engine and the GObject introspection framework. 

Suggest slight edit:

 Gjs allows using GNOME libraries from Javascript. It's based on the Spidermonkey Javascript engine from Mozilla and the GObject introspection framework. 

One missing BuildRequires noted below, otherwise looks good.(BuildRequires checked by inspection.)

#  MUST: rpmlint must be run on every package. 
OK:
 $ rpmlint ../SRPMS/gjs-0.3-1.fc11.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
$ rpmlint ../RPMS/i586/gjs-0.3-1.fc11.i586.rpm 
gjs.i586: W: shared-lib-calls-exit /usr/lib/libgjs-dbus.so.0.0.0 exit@GLIBC_2.0
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

The 1 warning is ignorable. [Implements standard dbus exit-on-disconnect-from-session-bus behavior to bring down session with the session bus]

# MUST: The package must be named according to the Package Naming Guidelines .
OK
# MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. [2] .
OK
# MUST: The package must meet the Packaging Guidelines .
OK
# MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
OK
# MUST: The License field in the package spec file must match the actual license. [3]
OK
# MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]
OK
# MUST: The spec file must be written in American English. [5]
OK
# MUST: The spec file for the package MUST be legible. [6]
OK
# MUST: The sources used to build the package must match the upstream source, as provided in the spec URL.
OK
# MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]
OK
# MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch.
NA
# MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
X

Needs BuildRequires: dbus-glib-devel

# MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.[9]
NA
# MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. [10]
OK
# MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package.
NA
# MUST: A package must own all directories that it creates.
OK
# MUST: A Fedora package must not list a file more than once in the spec file's %files listings. [13]
OK
# MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. [14]
OK
# MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [15]
OK
# MUST: Each package must consistently use macros. [16]
OK
# MUST: The package must contain code, or permissable content. [17]
OK
# MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [18]
OK
# MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. [18]
OK
# MUST: Header files must be in a -devel package. [19]
OK
# MUST: Static libraries must be in a -static package. [20]
NA
# MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability). [21]
OK
# MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. [19]
OK
# MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} [22]
OK
# MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.[20]
OK
# MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. 
NA
# MUST: Packages must not own files or directories already owned by other packages. 
OK
# MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [25]
OK
# MUST: All filenames in rpm packages must be valid UTF-8. [26]
OK

* SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. [27]


* SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available. [28]
NA
* SHOULD: The reviewer should test that the package builds in mock. [29]
Not tested
* SHOULD: The package should compile and build into binary rpms on all supported architectures. [30]
Not tested
* SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
OK
$ gjs-console 
gjs> const Gtk = imports.gi.Gtk
gjs> Gtk.init(None, None)
gjs> w.show()
gjs> Gtk.main()

Looks good.

* SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity. [31]
OK
* SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency. [22]
NA
* SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. 
OK
* SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. [32] 
NA
Comment 13 Peter Robinson 2009-08-07 12:14:57 EDT
OK. Updated everything except the make check (as it currently fails).

Failed make check can be seen here
http://koji.fedoraproject.org/koji/getfile?taskID=1589495&name=build.log

I also added the examples to the -devel package as they might be useful.

SPEC: as before
SRPM: http://pbrobinson.fedorapeople.org/gjs-0.3-2.fc11.src.rpm

koji build (without make check): http://koji.fedoraproject.org/koji/taskinfo?taskID=1589521
Comment 14 Owen Taylor 2009-08-07 12:26:02 EDT
Do you have:

 /builddir/build/BUILD/gjs-0.3/test_user_data/logs/stderr.log

? it worked for me in a non-mock build, so probably some mock interaction.

Having the make check isn't a blocker, but it would be nice to have eventually. Everything else looks good.
Comment 15 Peter Robinson 2009-08-07 12:33:15 EDT
New Package CVS Request
=======================
Package Name: gjs
Short Description: Javascript Bindings for GNOME
Owners: pbrobinson otaylor walters
Branches: F-11
InitialCC:
Comment 16 Kevin Fenzi 2009-08-07 16:00:38 EDT
cvs done.
Comment 17 Owen Taylor 2009-08-07 16:41:15 EDT
Peter: looks like Kevin misread the owners in the review request; just ask for approveacls in pkgdb and I'll approve it. (I don't mind co-maintaining the package.)
Comment 18 Peter Robinson 2009-08-08 07:51:52 EDT
Looks OK in pkgdb to me.

BTW built and on its way to rawhide.
Comment 19 Owen Taylor 2009-08-10 19:02:35 EDT
Don't know what I was looking at in pkgdb, indeed looks OK. Went ahead and filed a review request for a gnome-shell package using this package (bug 516654) - thanks for doing gjs!
Comment 20 Peter Robinson 2009-08-11 03:45:22 EDT
I also had it tagged into the alpha as well so it should be in todays rawhide as well. Thanks.
Comment 21 Peter Robinson 2009-08-11 09:36:10 EDT
Fixed as its now in rawhide. Thanks for your help.

Note You need to log in before you can comment on or make changes to this bug.